﻿/* The copyright in this software is being made available under the BSD
* License, included below. This software may be subject to other third party
* and contributor rights, including patent rights, and no such rights are
* granted under this license.
*
* Copyright (c) 2010-2019, ITU/ISO/IEC
* All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*
*  * Redistributions of source code must retain the above copyright notice,
*    this list of conditions and the following disclaimer.
*  * Redistributions in binary form must reproduce the above copyright notice,
*    this list of conditions and the following disclaimer in the documentation
*    and/or other materials provided with the distribution.
*  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
*    be used to endorse or promote products derived from this software without
*    specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
* ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
* BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
* SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
* INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
* THE POSSIBILITY OF SUCH DAMAGE.
*/

/** \file     MipData.h
\brief    weight and bias data for matrix-based intra prediction (MIP)
*/

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipMatrix4x4[18][16][4]) =
{
  {
    { 37,   59,   77,   28 },
    { 32,   92,   85,   25 },
    { 31,   69,  100,   24 },
    { 33,   36,  106,   29 },
    { 24,   49,  104,   48 },
    { 24,   21,   94,   59 },
    { 29,    0,   80,   72 },
    { 35,    2,   66,   84 },
    { 32,   13,   35,   99 },
    { 39,   11,   34,  103 },
    { 45,   21,   34,  106 },
    { 51,   24,   40,  105 },
    { 50,   28,   43,  101 },
    { 56,   32,   49,  101 },
    { 61,   31,   53,  102 },
    { 61,   32,   54,  100 }
  },
  {
    { 18,   16,   72,    2 },
    { 16,   19,   55,    7 },
    { 12,   72,   34,   14 },
    {  0,   84,   13,   21 },
    { 20,   19,   65,   54 },
    { 18,   19,   48,   65 },
    { 15,   23,   31,   73 },
    { 10,   27,   18,   76 },
    { 20,   21,   18,   87 },
    { 19,   21,   19,   87 },
    { 20,   20,   22,   85 },
    { 20,   20,   25,   84 },
    { 20,   21,   24,   82 },
    { 20,   20,   24,   82 },
    { 20,   22,   24,   82 },
    { 19,   23,   24,   82 }
  },
  {
    {  8,    7,   62,   10 },
    {  7,    0,   33,    9 },
    {  7,   12,    2,    6 },
    {  7,   63,    3,    6 },
    {  7,    7,   73,    6 },
    {  7,    8,   71,    9 },
    {  7,    1,   50,    9 },
    {  7,    9,   14,    7 },
    {  8,    7,   55,   22 },
    {  7,    7,   72,    5 },
    {  7,    9,   74,    7 },
    {  7,    3,   62,    9 },
    {  6,    6,    2,   77 },
    {  7,    6,   33,   45 },
    {  7,    7,   62,   14 },
    {  7,    8,   70,    8 }
  },
  {
    { 27,   27,   38,   28 },
    { 27,   30,   28,   28 },
    { 27,   58,   30,   26 },
    { 26,   66,   31,   25 },
    { 27,   26,   51,   27 },
    { 27,   37,   39,   26 },
    { 26,   64,   35,   26 },
    { 21,   63,   30,   31 },
    { 27,   26,   39,   47 },
    { 19,   43,   30,   51 },
    {  9,   56,   21,   54 },
    {  5,   50,   15,   56 },
    { 18,   27,   11,   72 },
    {  5,   45,   13,   64 },
    {  0,   48,   15,   59 },
    {  2,   48,   15,   58 }
  },
  {
    { 27,   19,   44,   22 },
    { 27,   35,   23,   27 },
    { 28,   88,   29,   28 },
    { 26,   91,   27,   27 },
    { 22,   21,   87,   25 },
    { 19,   22,   46,   20 },
    { 22,   69,   26,   20 },
    { 25,   87,   29,   23 },
    { 22,   23,   40,   81 },
    { 10,   16,   46,   66 },
    {  1,   17,   17,   50 },
    {  8,   37,    3,   40 },
    { 23,   25,   21,   92 },
    { 18,   24,   24,   91 },
    { 11,   16,   23,   88 },
    {  2,   11,    0,   81 }
  },
  {
    { 28,   28,   57,   29 },
    { 28,   27,   54,   29 },
    { 28,   32,   49,   28 },
    { 28,   45,   44,   28 },
    { 28,   29,   60,   27 },
    { 28,   30,   60,   29 },
    { 27,   29,   60,   29 },
    { 28,   29,   59,   30 },
    { 28,   29,   52,   36 },
    { 28,   29,   58,   28 },
    { 29,   30,   59,   27 },
    { 27,   33,   57,   28 },
    { 27,   28,   16,   71 },
    { 27,   28,   23,   65 },
    { 19,   29,   38,   47 },
    {  0,   35,   54,   20 }
  },
  {
    { 57,   57,   83,   54 },
    { 55,   55,   78,   53 },
    { 56,   70,   70,   54 },
    { 47,   97,   60,   52 },
    { 56,   57,   82,   64 },
    { 55,   56,   83,   62 },
    { 54,   66,   80,   59 },
    { 22,   79,   59,   43 },
    { 56,   56,   60,   83 },
    { 59,   58,   60,   86 },
    { 38,   54,   58,   73 },
    {  1,   62,   57,   35 },
    { 55,   56,   55,   88 },
    { 54,   54,   53,   89 },
    { 17,   40,   47,   70 },
    {  0,   60,   54,   38 }
  },
  {
    { 13,   10,   73,   12 },
    { 13,    3,   54,   15 },
    { 13,    0,   29,   14 },
    { 13,   22,   13,   13 },
    { 13,   13,   80,   10 },
    { 12,   14,   86,    7 },
    { 11,   11,   84,    8 },
    { 12,    3,   68,   11 },
    { 13,   12,   30,   59 },
    { 12,   10,   45,   43 },
    { 11,   11,   63,   26 },
    {  9,   11,   75,   15 },
    { 10,   10,    6,   83 },
    {  8,    9,    6,   83 },
    {  7,    8,    9,   78 },
    {  2,    5,   21,   63 }
  },
  {
    { 47,   46,   72,   50 },
    { 47,   45,   46,   57 },
    { 46,   69,   38,   51 },
    { 46,   80,   45,   49 },
    { 47,   48,   58,   68 },
    { 47,   45,   53,   72 },
    { 47,   57,   40,   64 },
    { 40,   76,   38,   50 },
    { 47,   47,   52,   73 },
    { 47,   47,   55,   72 },
    { 47,   48,   51,   74 },
    { 16,   56,   40,   51 },
    { 46,   46,   54,   72 },
    { 48,   48,   54,   72 },
    { 39,   43,   53,   71 },
    {  0,   35,   52,   51 }
  },
  {
    { 16,   39,   85,    0 },
    { 15,   49,   42,   39 },
    { 13,   30,   22,   66 },
    { 13,   18,   19,   74 },
    { 12,   19,   24,   73 },
    { 13,   11,   13,   83 },
    { 13,   12,   18,   78 },
    { 13,   15,   19,   75 },
    { 14,   15,   14,   78 },
    { 14,   16,   19,   75 },
    { 13,   17,   18,   75 },
    { 12,   17,   18,   75 },
    { 14,   16,   19,   75 },
    { 13,   16,   18,   76 },
    { 13,   16,   18,   76 },
    { 12,   16,   19,   75 }
  },
  {
    { 41,   37,   70,   35 },
    { 37,   27,   43,   37 },
    { 39,   74,   38,   38 },
    { 41,  113,   42,   40 },
    { 38,   40,  105,   43 },
    { 36,   32,   85,   38 },
    { 27,   28,   50,   34 },
    { 21,   83,   37,   31 },
    { 38,   39,   43,  102 },
    { 37,   39,   47,  100 },
    { 26,   27,   40,   94 },
    {  0,   25,   13,   78 },
    { 38,   39,   37,  105 },
    { 38,   40,   37,  105 },
    { 39,   42,   40,  106 },
    { 31,   35,   38,  102 }
  },
  {
    { 20,   20,   61,    8 },
    { 15,   13,   36,   10 },
    { 15,   15,   28,   12 },
    { 19,   51,   25,   14 },
    { 17,   19,   76,   39 },
    { 12,   17,   61,   40 },
    {  3,    7,   31,   42 },
    {  0,    1,    4,   46 },
    { 19,   20,   22,   85 },
    { 18,   20,   22,   86 },
    { 16,   21,   23,   85 },
    { 13,   19,   17,   84 },
    { 21,   21,   21,   84 },
    { 21,   22,   22,   83 },
    { 22,   22,   22,   84 },
    { 22,   23,   23,   83 }
  },
  {
    { 16,   14,   75,    3 },
    { 16,   43,   57,   16 },
    { 14,   63,   20,   43 },
    { 18,   46,    0,   65 },
    { 17,   20,   54,   52 },
    { 17,   22,   23,   76 },
    { 19,   17,   15,   83 },
    { 22,   17,   17,   82 },
    { 18,   17,   11,   84 },
    { 20,   18,   14,   83 },
    { 21,   20,   16,   81 },
    { 23,   21,   16,   81 },
    { 20,   18,   18,   80 },
    { 22,   19,   17,   81 },
    { 23,   20,   16,   82 },
    { 24,   20,   16,   82 }
  },
  {
    {  7,    6,   82,    0 },
    {  7,    4,   83,    0 },
    {  7,    2,   83,    0 },
    {  7,    3,   80,    0 },
    {  7,    8,   59,   16 },
    {  7,    8,   58,   17 },
    {  7,    8,   58,   17 },
    {  7,    7,   57,   18 },
    {  7,    7,    7,   70 },
    {  7,    7,    7,   71 },
    {  7,    7,    6,   71 },
    {  7,    8,    7,   70 },
    {  8,    7,    8,   71 },
    {  8,    7,    8,   70 },
    {  8,    7,    8,   70 },
    {  8,    7,    9,   69 }
  },
  {
    { 44,   41,   64,   43 },
    { 46,   60,   52,   42 },
    { 46,   81,   42,   53 },
    { 35,   71,   33,   65 },
    { 48,   51,   72,   50 },
    { 44,   65,   49,   65 },
    { 24,   56,   34,   71 },
    {  8,   38,   35,   66 },
    { 43,   50,   40,   80 },
    { 16,   39,   37,   71 },
    {  0,   28,   43,   61 },
    {  2,   29,   44,   60 },
    { 16,   33,   38,   71 },
    {  0,   25,   44,   58 },
    {  2,   26,   44,   60 },
    {  4,   28,   43,   61 }
  },
  {
    { 66,   86,   97,   69 },
    { 66,   99,   93,   67 },
    { 67,  100,   92,   68 },
    { 66,  104,   90,   67 },
    { 65,   94,  100,   63 },
    { 68,   98,   94,   70 },
    { 66,   99,   95,   67 },
    { 65,  102,   94,   66 },
    { 66,   86,  103,   67 },
    { 62,   98,  101,   55 },
    { 66,  101,   95,   66 },
    { 65,  102,   95,   66 },
    { 25,   69,   56,  123 },
    {  0,   91,   94,   43 },
    { 46,  100,  102,   50 },
    { 65,  100,   97,   65 }
  },
  {
    { 22,   20,   51,   22 },
    { 21,   22,   51,   22 },
    { 21,   29,   50,   22 },
    { 21,   32,   48,   22 },
    { 21,   23,   53,   22 },
    { 21,   24,   53,   22 },
    { 21,   23,   53,   22 },
    { 21,   24,   53,   22 },
    { 24,   24,   47,   28 },
    { 24,   24,   48,   27 },
    { 23,   25,   48,   26 },
    { 22,   25,   48,   26 },
    { 12,   16,    0,   71 },
    {  7,   14,    1,   67 },
    {  4,   14,    2,   64 },
    {  4,   13,    4,   63 }
  },
  {
    { 31,   29,   42,   33 },
    { 29,   42,   11,   47 },
    { 26,   63,   32,   31 },
    { 30,   49,   48,   26 },
    { 28,   30,   21,   56 },
    { 12,   46,   14,   37 },
    { 21,   52,   51,   18 },
    { 31,   38,   53,   29 },
    { 21,   37,   20,   52 },
    {  0,   42,   39,   10 },
    { 23,   38,   55,   22 },
    { 32,   36,   52,   33 },
    { 17,   45,   41,   27 },
    {  8,   37,   48,    8 },
    { 25,   33,   52,   27 },
    { 31,   36,   52,   32 }
  }
};

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t  mipOffsetMatrix4x4[18]) =
{ 34,   21,    7,   27,   27,   28,   56,   13,   47,   15,   40,   21,   16,    7,   45,   66,   21,   32 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipShiftMatrix4x4[18]) =
{  6,    6,    6,    5,    6,    5,    5,    6,    5,    6,    6,    6,    6,    6,    5,    6,    5,    5 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipMatrix8x8[10][16][8]) =
{
  {
    { 16,   22,   18,   20,   72,   43,    9,   19 },
    { 16,    8,   22,   26,   56,   58,    5,   20 },
    { 15,   21,   10,   35,   35,   72,    3,   20 },
    { 13,   21,   21,   29,   18,   78,    7,   18 },
    { 15,   16,   16,   19,    3,   70,   46,    8 },
    { 13,   18,   15,   20,    4,   58,   61,    4 },
    {  9,   16,   18,   18,    8,   42,   73,    3 },
    {  6,   14,   20,   18,   13,   30,   76,    6 },
    { 14,   18,   17,   17,   19,    4,   69,   40 },
    { 10,   18,   17,   16,   19,    3,   55,   51 },
    {  4,   14,   18,   15,   17,    5,   39,   63 },
    {  3,   14,   18,   16,   16,    8,   28,   70 },
    { 12,   15,   18,   16,   16,   20,    2,   92 },
    {  8,   14,   18,   15,   15,   19,    0,   91 },
    {  5,   15,   18,   16,   14,   19,    3,   88 },
    {  5,   16,   17,   17,   15,   17,    7,   84 }
  },
  {
    { 20,   35,   18,   20,   58,   35,   18,   20 },
    { 20,   75,   26,   19,   32,   31,   20,   20 },
    { 19,    6,   93,   22,   20,   25,   21,   20 },
    { 16,   25,    0,   99,   18,   21,   21,   18 },
    { 20,   28,   20,   20,    8,   78,   30,   19 },
    { 20,   67,   22,   20,   10,   59,   27,   19 },
    { 18,    7,   93,   18,   15,   30,   25,   20 },
    { 14,   25,    1,   97,   20,   18,   22,   18 },
    { 20,   28,   19,   20,   15,   14,   81,   25 },
    { 20,   59,   20,   20,   12,   22,   65,   23 },
    { 17,    7,   93,   16,   14,   24,   34,   22 },
    { 10,   24,    3,   95,   19,   20,   20,   18 },
    { 20,   29,   20,   20,   14,   23,    8,   90 },
    { 20,   51,   19,   21,   14,   19,   15,   77 },
    { 16,    7,   88,   16,   14,   20,   21,   43 },
    {  7,   22,    6,   91,   19,   18,   20,   21 }
  },
  {
    { 12,   19,   10,   12,   81,   14,   10,   11 },
    { 12,   26,   15,   10,   79,    6,   12,   11 },
    { 11,   16,   31,   12,   69,    2,   14,   10 },
    { 11,   13,    8,   44,   54,    3,   14,   10 },
    { 11,   11,   12,   11,    1,   83,   13,    9 },
    { 11,   12,   12,   12,   11,   83,    4,   12 },
    { 11,   15,   11,   13,   24,   77,    0,   12 },
    { 11,   14,   13,   16,   38,   63,    2,   12 },
    { 11,   12,   11,   11,   14,    2,   82,   12 },
    { 11,   13,   12,   12,   10,   14,   79,    5 },
    { 11,   12,   12,   13,    6,   29,   70,    3 },
    { 11,   12,   11,   16,    3,   45,   55,    4 },
    { 11,   12,   11,   12,   10,   12,    1,   84 },
    { 11,   13,   11,   12,   12,    8,   13,   76 },
    { 11,   12,   12,   13,   14,    3,   29,   64 },
    { 11,   13,   10,   17,   15,    0,   45,   49 }
  },
  {
    { 45,   74,   48,   44,   43,   62,   46,   48 },
    { 44,   77,   65,   47,   38,   46,   51,   51 },
    { 44,   46,   90,   61,   43,   41,   49,   52 },
    { 39,   43,   36,  116,   43,   42,   45,   52 },
    { 45,   75,   49,   44,   43,   47,   72,   51 },
    { 45,   65,   72,   48,   41,   35,   60,   61 },
    { 42,   41,   82,   67,   38,   41,   47,   63 },
    { 27,   46,   28,  115,   39,   44,   40,   57 },
    { 46,   68,   51,   45,   40,   44,   59,   78 },
    { 44,   55,   77,   48,   37,   43,   45,   79 },
    { 36,   38,   71,   74,   34,   44,   40,   72 },
    {  9,   52,   24,  106,   43,   38,   42,   54 },
    { 44,   58,   54,   45,   39,   46,   45,   94 },
    { 42,   46,   76,   50,   36,   48,   40,   85 },
    { 28,   41,   57,   80,   38,   42,   40,   73 },
    {  0,   56,   24,   99,   50,   28,   46,   54 }
  },
  {
    { 16,   32,   15,   16,   60,   34,   10,   19 },
    { 16,   68,   28,   13,   31,   37,   11,   17 },
    { 15,    8,   73,   23,   15,   30,   22,   14 },
    { 15,   18,    0,   85,   11,   17,   33,   15 },
    { 16,   18,   19,   17,    9,   56,   56,    9 },
    { 15,   19,   20,   16,   13,   30,   73,   12 },
    { 15,   20,   20,   18,   13,   13,   71,   28 },
    { 16,   18,   16,   26,   12,    8,   54,   47 },
    { 17,   16,   17,   17,   17,   10,   54,   51 },
    { 18,   17,   16,   18,   16,   15,   28,   73 },
    { 18,   18,   15,   18,   16,   20,   14,   83 },
    { 19,   19,   17,   18,   15,   21,   14,   82 },
    { 18,   17,   16,   18,   17,   18,    7,   90 },
    { 19,   18,   16,   19,   16,   17,   11,   87 },
    { 20,   18,   16,   20,   17,   15,   15,   84 },
    { 21,   19,   16,   22,   17,   15,   18,   81 }
  },
  {
    { 11,    6,   13,   11,   75,    6,   12,   11 },
    { 10,    3,    8,   13,   48,    2,   13,   10 },
    { 10,   45,    1,   13,   19,    9,   12,   10 },
    { 10,   42,   37,    8,   10,   12,   11,   10 },
    { 11,   11,   10,   12,   18,   74,    6,   11 },
    { 11,   12,   10,   12,   53,   47,    2,   12 },
    { 10,    6,   10,   12,   71,   16,    9,   11 },
    { 10,   15,    6,   13,   53,    5,   13,   10 },
    { 10,   12,   10,   11,    9,   17,   77,    5 },
    { 10,   11,    9,   12,    3,   51,   50,    2 },
    { 10,   11,    9,   12,   11,   72,   18,    8 },
    { 10,   11,    9,   12,   36,   57,    7,   10 },
    { 10,   10,   10,   11,   10,   10,   16,   71 },
    {  9,   11,   10,   11,   14,    0,   56,   39 },
    {  9,   11,    9,   12,   12,    8,   76,   13 },
    {  9,   12,    9,   12,    8,   35,   57,    7 }
  },
  {
    { 23,   21,   23,   23,  101,   30,   19,   25 },
    { 22,   13,   23,   24,  101,   29,   19,   25 },
    { 22,   24,   14,   23,  101,   29,   18,   24 },
    { 22,   23,   25,   17,   98,   29,   18,   24 },
    { 23,   24,   23,   23,    0,   97,   36,   17 },
    { 22,   25,   24,   22,    1,   97,   35,   17 },
    { 22,   22,   25,   23,    1,   96,   36,   17 },
    { 22,   22,   23,   24,    3,   94,   36,   17 },
    { 22,   23,   23,   22,   31,    0,   93,   34 },
    { 22,   23,   24,   23,   31,    2,   93,   33 },
    { 22,   22,   24,   23,   31,    1,   92,   34 },
    { 22,   22,   23,   23,   30,    3,   90,   35 },
    { 23,   24,   23,   23,   19,   31,    2,  102 },
    { 23,   23,   23,   24,   19,   30,    3,  101 },
    { 23,   23,   24,   24,   19,   30,    3,  101 },
    { 23,   23,   23,   24,   19,   31,    4,  100 }
  },
  {
    { 10,    5,   10,   10,   56,    4,   11,    9 },
    {  9,   22,    6,   10,   13,    9,   10,   10 },
    {  9,   67,   22,    6,   10,   10,   10,   10 },
    {  9,    6,   68,   18,   11,    9,   11,    9 },
    { 10,   10,   10,   10,   40,   53,    3,   11 },
    {  9,    6,   10,    9,   61,    9,   10,    9 },
    {  9,   17,    6,   10,   23,    7,    9,   10 },
    {  9,   56,   15,    8,   10,   11,    9,   10 },
    { 10,    9,   11,    9,    4,   42,   54,    3 },
    {  9,   10,   11,    9,   22,   67,    8,    8 },
    { 10,    7,   11,    9,   57,   23,    7,   10 },
    {  9,   11,   10,   10,   36,    8,   10,    9 },
    { 10,   10,   11,    9,   13,    0,   41,   50 },
    {  9,    9,   11,    9,    8,   24,   64,    8 },
    { 10,   10,   11,    9,   15,   63,   18,   10 },
    {  9,   10,   11,   10,   44,   33,   10,   11 }
  },
  {
    { 21,   44,   37,   20,   24,   68,   10,   23 },
    { 21,    1,   55,   39,   14,   39,   41,   18 },
    { 21,   25,    0,   68,   18,   18,   42,   39 },
    { 20,   24,   19,   36,   19,   14,   25,   72 },
    { 21,   11,   28,   30,   18,   23,   80,   19 },
    { 20,   25,    8,   38,   21,   13,   45,   62 },
    { 20,   22,   18,   25,   19,   18,   16,   90 },
    { 19,   21,   21,   24,   19,   21,   12,   91 },
    { 21,   22,   15,   28,   21,   20,   23,   82 },
    { 20,   21,   19,   24,   20,   22,    9,   95 },
    { 19,   21,   21,   22,   20,   21,   13,   92 },
    { 19,   22,   21,   22,   19,   21,   15,   90 },
    { 20,   21,   20,   22,   21,   22,   15,   90 },
    { 20,   21,   21,   22,   20,   21,   16,   89 },
    { 19,   21,   20,   23,   19,   22,   15,   89 },
    { 18,   21,   20,   23,   19,   23,   15,   87 }
  },
  {
    { 14,   15,   18,   15,   51,   68,   39,   23 },
    { 15,    4,   10,   20,   22,   76,   51,   27 },
    { 15,   16,    1,   17,   13,   78,   55,   29 },
    { 15,   13,   24,    0,   12,   76,   55,   27 },
    { 15,    8,   10,   14,   10,   66,   72,   25 },
    { 16,   12,    8,   14,   12,   59,   75,   27 },
    { 17,   13,    9,   12,   13,   58,   75,   28 },
    { 18,   14,    8,   13,   14,   60,   71,   29 },
    { 15,   10,   11,   12,   12,   42,   79,   41 },
    { 18,   14,    8,   14,   13,   45,   79,   39 },
    { 19,   14,    8,   14,   12,   44,   81,   38 },
    { 20,   15,   10,   14,   13,   45,   78,   36 },
    { 15,   11,   12,   13,   13,   24,   73,   62 },
    { 18,   15,    8,   13,   15,   28,   89,   43 },
    { 21,   14,   10,   14,   16,   29,   85,   45 },
    { 21,   16,    9,   15,   17,   33,   78,   46 }
  }
};

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipOffsetMatrix8x8[10]) =
{ 17,   20,   11,   45,   17,   11,   23,   10,   21,   11 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipShiftMatrix8x8[10]) =
{  6,    6,    6,    6,    6,    6,    6,    6,    6,    7 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipMatrix16x16[6][64][7]) =
{
  {
    { 46,    7,   14,   92,   23,   20,   10 },
    { 32,   22,   17,   52,   50,   25,   12 },
    {  1,   36,   21,   27,   61,   30,   14 },
    {  0,   30,   27,   17,   61,   32,   17 },
    { 13,   12,   37,   13,   59,   35,   18 },
    { 14,   13,   38,   11,   56,   38,   18 },
    { 10,   27,   29,    9,   55,   39,   17 },
    { 10,   27,   32,    7,   53,   38,   17 },
    {  8,   17,   14,   15,   92,   27,   13 },
    {  2,   16,   18,    8,   84,   38,   15 },
    {  4,   12,   22,    7,   76,   44,   17 },
    {  8,    8,   25,    7,   72,   46,   18 },
    {  8,    8,   26,    8,   69,   46,   19 },
    { 10,   11,   23,    9,   68,   47,   17 },
    { 10,   11,   23,    8,   67,   47,   18 },
    { 10,   12,   26,    9,   64,   43,   20 },
    {  7,   10,   16,   11,   86,   37,   17 },
    {  7,    9,   18,    9,   73,   47,   20 },
    {  8,    8,   21,    9,   67,   50,   22 },
    {  7,    9,   22,    9,   66,   50,   22 },
    {  7,    9,   23,    8,   67,   48,   22 },
    {  8,    9,   24,    8,   67,   48,   21 },
    {  8,    9,   26,    8,   66,   49,   20 },
    {  9,    8,   29,    8,   64,   48,   20 },
    {  8,    8,   16,    8,   69,   56,   19 },
    {  6,    9,   17,    8,   64,   55,   25 },
    {  7,    8,   19,    8,   62,   53,   27 },
    {  7,    8,   21,    8,   61,   52,   28 },
    {  7,    9,   22,    7,   62,   52,   25 },
    {  7,    9,   23,    6,   62,   53,   24 },
    {  8,    7,   26,    6,   62,   52,   23 },
    {  8,    8,   28,    6,   61,   51,   22 },
    {  7,    9,   14,    7,   49,   74,   23 },
    {  7,    7,   17,    7,   51,   65,   30 },
    {  7,    8,   18,    6,   53,   57,   33 },
    {  7,    8,   20,    5,   56,   57,   31 },
    {  7,    8,   22,    6,   56,   57,   29 },
    {  8,    8,   23,    5,   57,   57,   27 },
    {  8,    7,   26,    5,   57,   56,   26 },
    {  8,    6,   27,    5,   57,   55,   25 },
    {  7,    8,   14,    6,   36,   65,   47 },
    {  7,    7,   18,    5,   44,   59,   44 },
    {  7,    7,   19,    5,   47,   59,   40 },
    {  7,    7,   20,    5,   50,   59,   35 },
    {  8,    6,   22,    5,   51,   58,   33 },
    {  8,    5,   25,    5,   51,   59,   30 },
    {  7,    6,   26,    5,   51,   59,   29 },
    {  9,    6,   27,    5,   50,   59,   28 },
    {  7,    8,   14,    6,   27,   44,   76 },
    {  6,    8,   16,    5,   38,   57,   53 },
    {  6,    7,   19,    4,   44,   63,   40 },
    {  7,    6,   21,    4,   47,   62,   37 },
    {  8,    6,   22,    4,   47,   62,   35 },
    {  8,    6,   24,    5,   46,   64,   32 },
    {  8,    6,   26,    5,   46,   63,   31 },
    {  8,    6,   28,    6,   45,   62,   30 },
    {  8,    7,   15,    6,   22,   43,   81 },
    {  6,    8,   16,    5,   32,   64,   51 },
    {  8,    8,   19,    5,   37,   66,   41 },
    {  9,    5,   21,    4,   41,   67,   36 },
    {  8,    7,   22,    5,   42,   65,   35 },
    {  8,    6,   25,    6,   42,   64,   34 },
    {  9,    5,   27,    7,   43,   63,   32 },
    {  9,    5,   29,    8,   40,   60,   34 }
  },
  {
    { 50,   47,   46,   61,   50,   45,   46 },
    { 59,   49,   47,   57,   51,   45,   46 },
    { 64,   52,   48,   55,   51,   46,   46 },
    { 58,   61,   50,   53,   51,   46,   46 },
    { 52,   66,   53,   52,   51,   46,   46 },
    { 48,   62,   62,   50,   51,   46,   46 },
    { 47,   49,   76,   49,   51,   46,   46 },
    { 45,   33,   92,   49,   52,   46,   46 },
    { 50,   48,   46,   57,   63,   45,   46 },
    { 55,   52,   48,   55,   63,   45,   46 },
    { 57,   56,   50,   53,   63,   45,   46 },
    { 55,   60,   53,   51,   63,   46,   46 },
    { 51,   60,   59,   51,   63,   46,   46 },
    { 48,   55,   69,   49,   63,   46,   46 },
    { 46,   42,   84,   48,   62,   46,   46 },
    { 43,   28,   99,   48,   61,   47,   46 },
    { 49,   49,   47,   48,   73,   47,   46 },
    { 52,   52,   49,   47,   73,   48,   46 },
    { 52,   55,   53,   47,   72,   48,   46 },
    { 51,   56,   58,   46,   72,   48,   46 },
    { 48,   54,   65,   46,   71,   48,   46 },
    { 46,   47,   76,   45,   71,   49,   46 },
    { 44,   34,   91,   44,   70,   49,   46 },
    { 41,   23,  104,   45,   68,   50,   46 },
    { 48,   48,   48,   44,   68,   59,   45 },
    { 50,   51,   51,   43,   69,   58,   45 },
    { 49,   52,   56,   43,   68,   58,   45 },
    { 48,   52,   62,   42,   68,   58,   45 },
    { 45,   48,   71,   42,   68,   58,   45 },
    { 43,   38,   84,   41,   68,   59,   45 },
    { 41,   27,   98,   41,   67,   59,   45 },
    { 38,   19,  109,   42,   66,   59,   45 },
    { 47,   47,   49,   44,   52,   74,   45 },
    { 48,   48,   53,   43,   54,   74,   45 },
    { 47,   48,   60,   43,   55,   73,   45 },
    { 45,   46,   68,   43,   55,   73,   45 },
    { 43,   40,   78,   42,   56,   72,   45 },
    { 41,   30,   91,   42,   57,   72,   45 },
    { 38,   20,  105,   41,   57,   71,   45 },
    { 36,   13,  114,   41,   57,   70,   46 },
    { 46,   47,   50,   45,   43,   77,   51 },
    { 46,   46,   56,   44,   44,   78,   51 },
    { 45,   43,   64,   43,   45,   77,   51 },
    { 43,   39,   73,   43,   45,   77,   51 },
    { 40,   31,   85,   42,   46,   77,   51 },
    { 38,   22,   98,   42,   46,   77,   51 },
    { 35,   12,  111,   42,   47,   76,   51 },
    { 33,    7,  119,   41,   48,   75,   52 },
    { 46,   46,   51,   45,   44,   57,   71 },
    { 45,   43,   59,   44,   44,   58,   70 },
    { 43,   37,   68,   43,   45,   58,   70 },
    { 40,   31,   80,   43,   45,   58,   70 },
    { 38,   22,   92,   43,   46,   58,   70 },
    { 36,   13,  105,   43,   46,   58,   70 },
    { 33,    5,  117,   42,   47,   58,   70 },
    { 31,    2,  123,   42,   48,   57,   71 },
    { 45,   41,   55,   45,   51,   24,   96 },
    { 44,   36,   64,   44,   52,   23,   97 },
    { 42,   29,   75,   43,   53,   23,   97 },
    { 39,   22,   86,   43,   52,   24,   97 },
    { 37,   14,   98,   43,   53,   24,   97 },
    { 34,    7,  109,   42,   53,   25,   97 },
    { 32,    1,  118,   41,   53,   25,   97 },
    { 30,    0,  123,   41,   53,   26,   96 }
  },
  {
    { 20,   16,   16,   76,    9,   18,   16 },
    { 37,   15,   16,   71,   11,   17,   16 },
    { 65,   13,   17,   67,   12,   17,   16 },
    { 63,   30,   15,   63,   14,   17,   16 },
    { 30,   62,   13,   57,   16,   17,   16 },
    { 14,   62,   28,   52,   18,   16,   16 },
    { 21,   22,   64,   46,   21,   15,   16 },
    { 26,    0,   81,   40,   24,   15,   17 },
    { 23,   16,   16,   69,   48,    8,   18 },
    { 28,   18,   16,   66,   50,    8,   17 },
    { 36,   17,   17,   61,   54,    7,   18 },
    { 40,   20,   17,   56,   57,    7,   18 },
    { 34,   29,   18,   50,   61,    6,   18 },
    { 27,   34,   22,   44,   64,    5,   18 },
    { 25,   22,   37,   37,   67,    5,   18 },
    { 26,    9,   51,   31,   68,    6,   18 },
    { 18,   17,   17,   17,   87,    9,   17 },
    { 19,   17,   17,   15,   88,    9,   17 },
    { 20,   18,   17,   14,   88,   10,   17 },
    { 22,   17,   18,   12,   87,   12,   17 },
    { 23,   18,   19,   11,   85,   15,   16 },
    { 23,   20,   19,   11,   83,   18,   16 },
    { 22,   19,   22,   10,   79,   22,   16 },
    { 22,   16,   28,   11,   74,   26,   15 },
    { 16,   17,   16,    7,   58,   50,   10 },
    { 17,   17,   16,    8,   53,   55,   10 },
    { 18,   17,   17,   10,   47,   60,    9 },
    { 18,   16,   17,   11,   43,   64,    9 },
    { 19,   16,   17,   12,   38,   68,    9 },
    { 20,   17,   18,   13,   35,   72,    9 },
    { 20,   17,   19,   14,   31,   74,    9 },
    { 20,   16,   21,   13,   29,   74,   11 },
    { 17,   16,   16,   16,   15,   86,   11 },
    { 18,   15,   17,   16,   13,   86,   13 },
    { 18,   16,   16,   16,   13,   84,   15 },
    { 18,   15,   17,   16,   12,   82,   18 },
    { 19,   16,   17,   16,   12,   79,   21 },
    { 18,   16,   17,   16,   12,   76,   24 },
    { 18,   16,   17,   15,   12,   73,   28 },
    { 19,   16,   19,   15,   14,   68,   31 },
    { 17,   17,   16,   17,   10,   59,   43 },
    { 17,   16,   16,   17,   10,   54,   47 },
    { 18,   16,   16,   17,   11,   48,   52 },
    { 18,   16,   16,   16,   12,   44,   56 },
    { 17,   17,   16,   16,   13,   40,   59 },
    { 17,   17,   16,   16,   13,   37,   62 },
    { 17,   17,   17,   15,   14,   34,   65 },
    { 18,   16,   18,   16,   14,   32,   66 },
    { 17,   16,   16,   15,   16,   17,   79 },
    { 17,   16,   16,   16,   16,   15,   81 },
    { 18,   16,   16,   16,   16,   14,   82 },
    { 18,   16,   16,   15,   16,   13,   83 },
    { 17,   18,   16,   15,   16,   13,   83 },
    { 17,   17,   17,   15,   16,   13,   84 },
    { 17,   17,   17,   15,   16,   13,   84 },
    { 17,   16,   18,   15,   16,   13,   83 },
    { 16,   16,   16,   16,   17,    3,   92 },
    { 17,   16,   16,   15,   17,    4,   91 },
    { 18,   17,   17,   14,   18,    4,   90 },
    { 18,   17,   16,   14,   18,    4,   91 },
    { 17,   18,   16,   15,   18,    4,   91 },
    { 17,   18,   17,   15,   18,    4,   90 },
    { 17,   17,   18,   14,   18,    4,   90 },
    { 18,   16,   19,   15,   18,    5,   89 }
  },
  {
    { 13,    9,   10,   43,   11,   12,    9 },
    { 43,    2,   11,   22,   15,   12,   10 },
    { 73,    2,   11,   16,   16,   12,    9 },
    { 52,   38,    5,   13,   16,   12,   10 },
    { 11,   71,    6,   12,   14,   13,   10 },
    {  3,   50,   35,   10,   14,   13,    9 },
    { 11,   12,   68,   11,   13,   13,   10 },
    { 13,    3,   74,   12,   11,   15,   10 },
    { 20,    9,   10,   51,   29,   11,   10 },
    { 41,    5,   10,   37,   26,   13,   10 },
    { 58,    9,   10,   23,   27,   14,    9 },
    { 41,   36,    6,   15,   24,   16,   10 },
    { 14,   57,   11,   11,   21,   18,    9 },
    {  7,   39,   37,    9,   18,   19,    9 },
    { 12,    9,   63,   10,   15,   20,    9 },
    { 15,    2,   68,   11,   12,   21,   10 },
    { 16,   11,   11,   19,   60,   11,   11 },
    { 27,   11,   11,   20,   50,   16,   10 },
    { 35,   15,   11,   17,   42,   20,   10 },
    { 29,   29,   11,   12,   35,   23,   10 },
    { 17,   37,   18,    8,   29,   26,    9 },
    { 13,   26,   35,    6,   24,   27,    9 },
    { 15,    8,   53,    7,   19,   27,   10 },
    { 16,    4,   57,    9,   14,   28,   11 },
    { 12,   11,   11,    5,   51,   36,    8 },
    { 15,   13,   12,    8,   45,   36,    9 },
    { 19,   16,   14,    9,   38,   38,    9 },
    { 19,   21,   16,    8,   32,   39,   10 },
    { 18,   22,   21,    7,   27,   39,   10 },
    { 18,   16,   31,    7,   22,   39,   11 },
    { 18,    9,   41,    6,   18,   39,   11 },
    { 19,    7,   44,    7,   15,   37,   13 },
    { 11,   12,   11,    9,   18,   64,   10 },
    { 11,   12,   13,   10,   18,   61,   11 },
    { 13,   13,   15,   10,   17,   58,   12 },
    { 15,   14,   17,   10,   16,   56,   13 },
    { 17,   14,   20,    9,   14,   55,   13 },
    { 18,   11,   26,    9,   13,   52,   14 },
    { 19,    9,   31,    8,   11,   50,   15 },
    { 19,    9,   33,    8,   10,   46,   17 },
    { 10,   11,   12,   11,    4,   59,   28 },
    { 11,   10,   13,   11,    4,   60,   26 },
    { 12,   10,   15,   11,    5,   59,   25 },
    { 14,   10,   16,   11,    5,   58,   24 },
    { 15,   10,   18,   11,    4,   57,   24 },
    { 17,    9,   21,   11,    4,   56,   24 },
    { 19,    9,   23,   10,    4,   53,   24 },
    { 19,    9,   26,   10,    5,   49,   25 },
    { 10,   10,   12,   11,    5,   27,   60 },
    { 11,    8,   14,   11,    3,   34,   54 },
    { 13,    8,   15,   12,    2,   38,   50 },
    { 13,    8,   15,   13,    1,   41,   47 },
    { 15,    8,   17,   13,    0,   42,   45 },
    { 16,    8,   18,   13,    0,   44,   43 },
    { 18,    8,   19,   12,    0,   44,   41 },
    { 19,    9,   21,   12,    1,   43,   39 },
    { 11,    8,   12,   11,    6,    9,   77 },
    { 13,    7,   13,   12,    4,   16,   72 },
    { 15,    6,   14,   13,    2,   21,   67 },
    { 15,    6,   14,   13,    1,   25,   63 },
    { 15,    7,   15,   14,    0,   27,   61 },
    { 16,    8,   15,   14,    0,   29,   58 },
    { 17,    8,   17,   14,    0,   29,   56 },
    { 18,    8,   18,   14,    1,   30,   53 }
  },
  {
    { 15,   13,   13,   55,   12,   13,   13 },
    { 21,   13,   13,   34,   14,   13,   13 },
    { 39,   12,   13,   22,   14,   13,   13 },
    { 55,   18,   12,   18,   14,   14,   13 },
    { 48,   37,   11,   16,   14,   14,   13 },
    { 23,   62,   13,   14,   14,   13,   13 },
    { 11,   53,   35,   14,   14,   13,   12 },
    { 15,   13,   72,   14,   14,   13,   12 },
    { 16,   13,   13,   63,   27,   12,   13 },
    { 17,   13,   13,   58,   19,   13,   13 },
    { 22,   13,   13,   43,   18,   13,   13 },
    { 33,   14,   12,   31,   17,   14,   13 },
    { 45,   18,   12,   24,   16,   14,   12 },
    { 44,   32,   12,   19,   15,   14,   13 },
    { 29,   49,   15,   17,   14,   14,   12 },
    { 18,   44,   33,   16,   15,   13,   12 },
    { 15,   13,   13,   32,   60,   10,   13 },
    { 16,   13,   13,   45,   44,   12,   13 },
    { 17,   14,   13,   49,   32,   13,   12 },
    { 21,   14,   13,   44,   25,   14,   12 },
    { 30,   14,   13,   37,   21,   14,   12 },
    { 39,   16,   13,   30,   18,   14,   12 },
    { 39,   27,   13,   24,   17,   14,   12 },
    { 31,   38,   16,   21,   17,   13,   12 },
    { 13,   13,   13,   13,   64,   27,   11 },
    { 14,   13,   13,   23,   61,   19,   12 },
    { 15,   14,   13,   34,   51,   16,   12 },
    { 17,   14,   13,   40,   42,   15,   12 },
    { 20,   14,   13,   40,   34,   14,   12 },
    { 27,   14,   13,   37,   29,   14,   12 },
    { 33,   16,   13,   32,   25,   13,   12 },
    { 33,   24,   14,   27,   23,   13,   12 },
    { 13,   13,   13,   13,   33,   61,    9 },
    { 13,   13,   13,   15,   47,   44,   10 },
    { 14,   13,   13,   20,   54,   31,   11 },
    { 15,   13,   13,   27,   53,   23,   11 },
    { 16,   14,   13,   32,   49,   18,   12 },
    { 19,   14,   13,   34,   43,   15,   12 },
    { 24,   14,   13,   34,   37,   14,   12 },
    { 28,   17,   13,   31,   32,   14,   12 },
    { 13,   14,   13,   15,   10,   71,   20 },
    { 13,   13,   13,   15,   22,   66,   13 },
    { 14,   13,   13,   15,   37,   53,   11 },
    { 14,   13,   13,   18,   47,   40,   11 },
    { 14,   13,   13,   23,   52,   29,   11 },
    { 15,   14,   13,   27,   51,   23,   11 },
    { 18,   14,   13,   30,   47,   19,   11 },
    { 22,   15,   13,   30,   42,   17,   12 },
    { 13,   13,   13,   14,   12,   34,   57 },
    { 13,   13,   13,   15,   14,   50,   38 },
    { 13,   13,   13,   15,   21,   58,   23 },
    { 14,   13,   13,   16,   32,   54,   16 },
    { 13,   13,   13,   18,   41,   45,   13 },
    { 13,   14,   13,   21,   47,   36,   12 },
    { 14,   14,   13,   24,   49,   28,   12 },
    { 17,   14,   13,   26,   46,   24,   12 },
    { 13,   13,   13,   13,   19,    0,   85 },
    { 13,   13,   13,   13,   20,   12,   72 },
    { 13,   13,   13,   15,   20,   30,   53 },
    { 13,   13,   13,   16,   23,   44,   35 },
    { 13,   14,   12,   17,   29,   47,   24 },
    { 13,   14,   13,   18,   36,   44,   18 },
    { 13,   14,   13,   20,   41,   38,   16 },
    { 15,   14,   14,   22,   42,   33,   15 }
  },
  {
    { 24,    9,   10,   52,   13,   10,   12 },
    { 53,    9,   10,   25,   26,    6,   13 },
    { 48,   30,    9,   11,   30,    7,   13 },
    { 15,   59,   12,    6,   25,   13,   11 },
    {  5,   48,   34,    7,   18,   19,   10 },
    { 10,   15,   62,    8,   12,   20,   13 },
    { 13,    2,   70,    8,    9,   19,   19 },
    { 13,    3,   62,    9,    6,   16,   30 },
    { 25,   14,   10,   40,   51,    0,   14 },
    { 20,   28,   11,   16,   55,    5,   13 },
    {  8,   38,   18,    6,   41,   20,   11 },
    {  5,   28,   34,    6,   23,   31,   12 },
    {  9,   12,   48,    8,   12,   33,   18 },
    { 12,    2,   53,    9,    6,   30,   28 },
    { 14,    1,   50,    9,    4,   23,   40 },
    { 14,    5,   42,    8,    4,   15,   51 },
    {  8,   20,   12,    5,   72,   12,   12 },
    {  2,   24,   19,    5,   46,   35,    9 },
    {  5,   16,   29,    9,   21,   48,   13 },
    {  9,    6,   36,   10,    9,   45,   25 },
    { 12,    3,   37,   11,    5,   36,   38 },
    { 13,    4,   34,   11,    4,   25,   51 },
    { 13,    6,   29,   10,    4,   16,   61 },
    { 13,    9,   26,   10,    6,   11,   66 },
    {  6,   14,   15,    6,   31,   60,    6 },
    {  7,   10,   22,   11,   12,   64,   15 },
    { 10,    6,   26,   13,    6,   50,   32 },
    { 11,    4,   27,   12,    5,   33,   49 },
    { 12,    5,   25,   11,    6,   20,   62 },
    { 12,    7,   22,   11,    7,   13,   69 },
    { 12,    9,   19,   11,    7,    8,   74 },
    { 12,   10,   19,   10,    8,    7,   74 },
    { 10,    9,   16,   12,    6,   67,   20 },
    { 11,    6,   20,   13,    5,   46,   41 },
    { 11,    5,   21,   12,    7,   26,   59 },
    { 11,    7,   19,   12,    9,   14,   70 },
    { 11,    8,   18,   11,   10,    8,   75 },
    { 11,    9,   16,   11,   10,    5,   78 },
    { 12,   10,   15,   11,   10,    4,   80 },
    { 11,   10,   15,   10,   10,    4,   78 },
    { 11,    9,   15,   12,    8,   34,   54 },
    { 11,    7,   17,   11,   10,   16,   69 },
    { 11,    7,   17,   11,   11,    7,   76 },
    { 11,    8,   16,   11,   11,    4,   80 },
    { 10,   10,   14,   11,   11,    3,   81 },
    { 11,   10,   13,   11,   12,    2,   82 },
    { 11,   10,   13,   11,   12,    2,   82 },
    { 11,   11,   13,   10,   12,    3,   80 },
    { 11,    9,   14,   11,   11,    8,   77 },
    { 11,    8,   14,   11,   12,    3,   81 },
    { 11,    9,   14,   11,   12,    1,   83 },
    { 10,   10,   13,   11,   12,    2,   83 },
    { 10,   11,   12,   11,   12,    2,   82 },
    { 10,   11,   12,   11,   12,    3,   82 },
    { 11,   11,   11,   11,   12,    3,   81 },
    { 11,   11,   11,   11,   13,    5,   79 },
    { 11,   10,   13,   11,   13,    2,   82 },
    { 11,    9,   13,   11,   13,    1,   83 },
    { 11,   10,   12,   11,   13,    2,   82 },
    { 10,   11,   12,   11,   12,    3,   81 },
    { 10,   11,   12,   11,   12,    4,   80 },
    { 10,   11,   11,   11,   12,    5,   80 },
    { 11,   11,   11,   11,   13,    5,   79 },
    { 11,   11,   11,   11,   12,    6,   77 }
  }
};

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipOffsetMatrix16x16[6]) =
{  8,   46,   16,   10,   13,   11 };

ALIGN_DATA(MEMORY_ALIGN_DEF_SIZE, const uint8_t mipShiftMatrix16x16[6]) =
{  7,    5,    6,    6,    6,    6 };
